/* eslint-disable no-case-declarations */
import c from './consts';
import phin from 'phin';
const valid = ['angry', 'bonk', 'cry', 'happy', 'hug', 'kiss', 'lol', 'nom', 'pat', 'pout', 'smug', 'uwu', 'wink'];

async function get(url: string, headers: string) {
  return await phin({
    method: 'get',
    url: url,
    headers: {
      'User-Agent': headers,
    },
    parse: 'json',
    timeout: 10000
  });
}

function randomArray(arr: string, path: string) {
  return `${path}/${arr[Math.floor(Math.random() * arr.length)]}`;
}

export default async function request(options:
    {
        category: 'fgo' | 'genshin' | 'azur' | 'waifu' | 'sex' | 'gelbooru' | 'reaction',
        tags?: string | string[],
        apikey?: string,
        limit?: number,
        block?: string | string[],
        page?: number,
        useragent?: string,
        img?: string
    }
) {

  switch (options.category) {

        

  case 'fgo':
    return (await get(c.endpoint.fgo, options.useragent || '')).body;
  case 'genshin':
    return (await get(c.endpoint.genshin, options.useragent || '')).body;
  case 'azur':
    return (await get(c.endpoint.azur, options.useragent || '')).body;
  case 'waifu':
    return (await get(c.endpoint.waifu, options.useragent || '')).body;
  case 'sex':
    return (await get(c.endpoint.sex, options.useragent || '')).body;
  case 'reaction':
            
    if (!options.img) throw Error('No Tags provided');
    
    if (!valid.includes(options.img))
      throw Error('Invalid parameter, please use one of the following: ' + valid.join(', '));

    //return { url: `https://gitlab.com/d0g/servant/-/raw/master/${options.img}/${res[Math.floor(Math.random() * res.length)]}`};
    const res: unknown = (await get(`${c.endpoint.reaction}/${options.img}.json`, options.useragent || '')).body;
    const gambar: string = await res as string;
    return { url: randomArray(gambar, `https://gitlab.com/d0g/servant/-/raw/master/${options.img}`) };
            

  default:
    return {
      success: false,
      message: 'No URL provided'
    };
  }


}